// request
#[derive(Serialize, Deserialize, Debug, Clone)]
pub struct GetBlockRequest {
    pub height: Option<u32>,
    pub hash: Option<String>
}

// response
#[derive(Serialize, Deserialize, Debug, Clone)]
pub struct GetBlockResponse {
    pub block_header: BlockHeader,
    pub status: String,
    pub credits: u32,
    pub miner_tx_hash: String,
    pub top_hash: String,
    pub untrusted: bool
}

// data
#[derive(Serialize, Deserialize, Debug, Clone)]
pub struct BlockHeader {
    pub block_size: u32,
    pub block_weight: u32,
    pub cumulative_difficulty: u32,
    pub cumulative_difficulty_top64: u32,
    pub depth: u32,
    pub difficulty: u64,
    pub difficulty_top64: u64,
    pub hash: String,
    pub height: u32,
    pub long_term_weight: u32,
    pub major_version: u8,
    pub minor_version: u8,
    pub miner_tx_hash: Option<String>,
    pub nonce: u32,
    pub num_txes: u32,
    pub orphan_status: bool,
    pub pow_hash: String,
    pub prev_hash: String,
    pub reward: u64,
    pub timestamp: i64,
    pub wide_cumulative_difficulty: String,
    pub wide_difficulty: String
}

// #[derive(Serialize, Deserialize, Debug, Clone)]
// pub struct GetBlockResult {
//     pub block_header: BlockHeader,
//     pub credits: u8,
//     pub miner_tx_hash: String,
//     pub tx_hashes: Option<Vec<String>>,
// }

