// mod node;

use super::node::GetInfoResponse;
use super::block::GetBlockResponse;

// Options for various response payloads
#[derive(Deserialize, Serialize, Debug, Clone)]
#[serde(untagged)]
pub enum RPCResponseOpt {
    GetInfoResponse(GetInfoResponse),
    GetBlockResponse(GetBlockResponse)
}

// // Options for various request payloads
// #[derive(Deserialize, Serialize, Debug, Clone)]
// #[serde(untagged)]
// pub enum RPCRequestOpt {
//     GetInfoResponse(GetInfoResponse)
// }

// Default RPC response payload
#[derive(Serialize, Deserialize, Debug, Clone)]
pub struct RPCResponse {
    pub jsonrpc: Option<String>,
    pub id: Option<String>,
    pub result: Option<RPCResponseOpt>
}

// // Default RPC request payload
// #[derive(Serialize, Deserialize, Debug, Clone)]
// pub struct RPCRequest {
//     pub jsonrpc: String,
//     pub id: String,
//     pub method: Option<String>,
//     pub params: Option<RPCRequestOpt>
// }

// impl Default for RPCRequest {
//     fn default() -> RPCRequest {
//         RPCRequest {
//             jsonrpc: "2.0".to_string(),
//             id: "0".to_string(),
//             method: None,
//             params: None
//         }
//     }
// }

